Build Image:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - printenv
    - ls -la
    - echo $CI_PROJECT_DIR
    - echo $REPO_DIR
    - CI_JOB_TIMESTAMP=$(date --utc +%Y-%m-%d)
    - CI_COMMIT_SHORT_SHA=$(echo $CI_COMMIT_SHA | cut -c 1-8)
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "gitlab-ci-token" "${CI_JOB_TOKEN}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --build-arg CI_REGISTRY=${CI_REGISTRY}
      --build-arg CI_COMMIT_BRANCH=${CI_COMMIT_BRANCH}
      --build-arg GITLAB_CI_ACCESS=${GITLAB_CI_ACCESS}
      --build-arg GITLAB_CI_TOKEN=${GITLAB_CI_TOKEN}
      --build-arg CI_COMMIT_BRANCH=${CI_COMMIT_BRANCH}
      --build-arg CI_REPOSITORY_URL=${CI_REPOSITORY_URL}
      --build-arg REPO_DIR=${REPO_DIR}
      --cache=false
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/pipeline/Dockerfiles/$DOCKER_FILE"
      --destination $CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:build-$CI_JOB_TIMESTAMP-commit-$CI_COMMIT_SHORT_SHA
      --destination $CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:latest

    - echo $CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:build-$CI_JOB_TIMESTAMP-commit-$CI_COMMIT_SHORT_SHA > image_tag.txt

  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - pipeline/

  artifacts:
    paths:
      - image_tag.txt
    expire_in: 30 minutes
  only:
    - dev
    - uat
    - main
